"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var Singletons = _interopRequireWildcard(require("./singletons.js"));

var _create = require("./methods/create.js");

var _environment = require("./methods/environment.js");

var _function = require("./methods/function.js");

var _havoc = require("./utils/havoc.js");

var _join = require("./methods/join.js");

var _paths = require("./utils/paths.js");

var _properties = require("./methods/properties.js");

var _to = require("./methods/to.js");

var _widen = require("./methods/widen.js");

var _ConcreteModelConverter = require("./utils/ConcreteModelConverter.js");

var _DebugReproManager = require("./utils/DebugReproManager.js");

var utils = _interopRequireWildcard(require("./utils.js"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

/**
 * Copyright (c) 2017-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */
function _default() {
  Singletons.setCreate(new _create.CreateImplementation());
  Singletons.setEnvironment(new _environment.EnvironmentImplementation());
  Singletons.setFunctions(new _function.FunctionImplementation());
  Singletons.setHavoc(new _havoc.HavocImplementation());
  Singletons.setMaterialize(new _havoc.MaterializeImplementation());
  Singletons.setJoin(new _join.JoinImplementation());
  Singletons.setPath(new _paths.PathImplementation());
  Singletons.setProperties(new _properties.PropertiesImplementation());
  Singletons.setTo(new _to.ToImplementation());
  Singletons.setWiden(new _widen.WidenImplementation());
  Singletons.setConcretize(_ConcreteModelConverter.concretize);
  Singletons.setUtils(utils);
  Singletons.setDebugReproManager(new _DebugReproManager.DebugReproManagerImplementation());
}
//# sourceMappingURL=initialize-singletons.js.map