"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _index = require("../../values/index.js");

var _singletons = require("../../singletons.js");

var _typedarray = require("../../methods/typedarray.js");

/**
 * Copyright (c) 2017-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

/*  strict-local */
function _default(realm) {
  // ECMA262 22.1.3.30
  return new _index.NativeFunctionValue(realm, "Array.prototype.values", "values", 0, context => {
    // 1. Let O be ? ToObject(this value).
    let O = _singletons.To.ToObject(realm, context); // 2. Perform ? ValidateTypedArray(O).


    (0, _typedarray.ValidateTypedArray)(realm, O); // 3. Return CreateArrayIterator(O, "value").

    return _singletons.Create.CreateArrayIterator(realm, O.throwIfNotConcreteObject(), "value");
  });
}
//# sourceMappingURL=TypedArrayProto_values.js.map